local B = CBW_Battle
CBW_Battle.ControlPoint = {}
local CP = B.ControlPoint
local CV = B.Console
CP.Num = 0
CP.Mode = false
CP.ID = {}
CP.TeamCapAmt = {0,0}
CP.LeadCapPlr = nil
CP.LeadCapAmt = 0
CP.Active = false
CP.Capturing = false
CP.Blocked = false
CP.Timer = 0
CP.HintSFX = sfx_prloop
CP.AppearSFX = sfx_ngdone
CP.StartCaptureSFX = sfx_drill1
CP.CapturingSFX = sfx_drill2
CP.BlockSFX = sfx_ngskid
CP.WinSFX = sfx_hidden
CP.LoseSFX = sfx_nxitem
CP.SFXtic = 1

CP.Gametype = function()
	if gametype == GT_CP or gametype == GT_TEAMCP return true end
	return false
end

CP.RefreshPoints = function()
	CP.TeamCapAmt[1] = 0
	CP.TeamCapAmt[2] = 0
	CP.LeadCapPlr = nil
	CP.LeadCapAmt = 0
	CP.Blocked = false
	CP.Capturing = false
	for player in players.iterate()
		player.captureamount = 0
		player.capturing = 0
	end
end

CP.Reset = function()
	CP.Mode = false
	CP.Active = false
	CP.ID = {}
	CP.Timer = CV.CPWait.value*TICRATE
	CP.RefreshPoints()
end

CP.Generate = function()
	if not(CP.Gametype()) then return end
	CP.ID = {}
	local id = {}
	local n = 1
	print("Checking map things for Control Point spawn placement")
	for mapthing in mapthings.iterate
		if not(mapthing.type >= 330 and mapthing.type <= 335) and not(mapthing.type == 303) then continue end
		print("Spawning for thing type "..mapthing.type)
		local fu = FRACUNIT
		local x = mapthing.x*fu
		local y = mapthing.y*fu
		local z = mapthing.z*fu
-- 		print(x/fu..","..y/fu..","..z/fu)
		local subsector = R_PointInSubsector(x,y)
		if subsector.valid and subsector.sector then
			z = $+subsector.sector.floorheight
-- 			print(z/fu)
			local mo = P_SpawnMobj(x,y,z,MT_CONTROLPOINT)			
-- 			print(mo.x..","..mo.y..","..mo.z)
			id[n] = mo
			n = $+1
		end
	end
	local size = #id
	if size then
		print("Doing shuffle for CPs amount:" ..size)
		for n = 1,size
			while CP.ID[n] == nil 
				local r = P_RandomRange(1,size)
				CP.ID[n] = id[r]
				id[r] = nil
			end
			if CP.ID[n] != nil then
-- 				print("#"..n.." recorded as id:")
-- 				print(CP.ID[n])
			end
		end		
		print("Shuffled all CP ids")
		CP.Mode = true
		CP.Num = 1
	else
		print("No valid CP spawn points for current map")
		CP.Mode = false
	end
end

local function Wrap(num,size)
	if num > size then
		num = $-size
	end
	return num
end

CP.ActivatePoint = function()
	if CP.Num and CP.ID[CP.Num] and CP.ID[CP.Num].valid then
		CP.Active = true
		CP.RefreshPoints()
		S_StartSound(nil,CP.AppearSFX)
		print("A\x82 Control Point\x80 has been unlocked!")
	else
		print("\x82 Error:\x80 Invalid control point!")
		CP.Mode = false
	end
end

CP.SeizePoint = function()
	if G_GametypeHasTeams() then	//Teams
		local victor = 0
		if CP.TeamCapAmt[1] > CP.TeamCapAmt[2] then
			victor = 1
			print("\x85 Red Team captured the Control Point!")
			redscore = $+1
		end
		if CP.TeamCapAmt[2] > CP.TeamCapAmt[1] then
			victor = 2			
			print("\x84 Blue Team captured the Control Point!")
			bluescore = $+1
		end
		if consoleplayer and consoleplayer.ctfteam == victor then
			S_StartSound(nil,CP.WinSFX)
		else
			S_StartSound(nil,CP.LoseSFX)
		end
	elseif CP.LeadCapPlr and CP.LeadCapPlr.valid then //Free for all
		print(CP.LeadCapPlr.name.." captured the Control Point!")
		P_AddPlayerScore(CP.LeadCapPlr,CV.CPBonus.value)
		
		if consoleplayer == CP.LeadCapPlr then
			S_StartSound(nil,CP.WinSFX)
		else
			S_StartSound(nil,CP.LoseSFX)
		end
	end
	CP.RefreshPoints()
	CP.Active = false
	CP.Num = Wrap($+1,#CP.ID)
	CP.Timer = CV.CPWait.value*TICRATE
end

CP.PointHover = function(mo,floor,flip,ceil)
	//Do Hover
	local hover_amount = flip*mo.scale*CV.CPHeight.value/2-mo.height/2
-- 	local hover_amount = flip*min(mo.scale*64,(floor+ceil)/2*flip)
	local hover_speed = mo.scale*4
	local hover_accel = hover_speed/12
	if mo.z > hover_amount+floor then
		mo.momz = max(-hover_speed,$-hover_accel)
	end
	if mo.z < hover_amount+floor then	
		mo.momz = min(hover_speed,$+hover_accel)
	end	
end

CP.ActiveThinker = function(mo,floor,flip,ceil)
	//Do point dimensions
	local radius = CV.CPRadius.value*mo.scale
	local height = CV.CPHeight.value*mo.scale
	mo.flags2 = ($|MF2_INVERTAIMABLE)&~MF2_SHADOW
	
	local function randomcolor() 
		if G_GametypeHasTeams() then return mo.color
		else return P_RandomRange(1,MAXSKINCOLORS-1) 
		end
	end
	
	local function visual_cp(mo,floor,radius,fuse,quadrants,color)
		for n = 1,8
			local t
			local item = MT_CPBONUS
			if n == 1 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle,radius),mo.y+P_ReturnThrustY(mo,mo.angle,radius),floor,item)
			elseif n == 2 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle+ANGLE_90,radius),mo.y+P_ReturnThrustY(mo,mo.angle+ANGLE_90,radius),floor,item)
			elseif n == 3 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle+ANGLE_180,radius),mo.y+P_ReturnThrustY(mo,mo.angle+ANGLE_180,radius),floor,item)
			elseif n == 4 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle+ANGLE_270,radius),mo.y+P_ReturnThrustY(mo,mo.angle+ANGLE_270,radius),floor,item)
			elseif n == 5 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle+ANGLE_45,radius),mo.y+P_ReturnThrustY(mo,mo.angle+ANGLE_45,radius),floor,item)
			elseif n == 6 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle+ANGLE_135,radius),mo.y+P_ReturnThrustY(mo,mo.angle+ANGLE_135,radius),floor,item)
			elseif n == 7 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle+ANGLE_225,radius),mo.y+P_ReturnThrustY(mo,mo.angle+ANGLE_225,radius),floor,item)
			elseif n == 8 then t = P_SpawnMobj(mo.x+P_ReturnThrustX(mo,mo.angle+ANGLE_315,radius),mo.y+P_ReturnThrustY(mo,mo.angle+ANGLE_315,radius),floor,item)
			end
			if t and t.valid then
				t.color = color
				t.fuse = fuse
				t.extravalue1 = t.fuse
			end
			if quadrants and n >= 4 then break end
		end
	end
	
	//Visuals
	mo.angle = $+ANG1*2
	visual_cp(mo,floor,radius,16,false,randomcolor())
	visual_cp(mo,floor,radius,16,false,randomcolor())
	visual_cp(mo,floor+height/4,radius/8,2,true,mo.color)
	visual_cp(mo,floor+height/8,radius/16,2,true,mo.color)
	visual_cp(mo,height+floor,radius,16,false,randomcolor())
	visual_cp(mo,height*3/4+floor,radius/8,2,true,mo.color)
	visual_cp(mo,height*7/8+floor,radius/16,2,true,mo.color)

	mo.color = SKINCOLOR_JET

	//Get capturers
	local team = {0,0}
	local activeplayers = 0
	local captureplayers = 0
	for player in players.iterate()
		player.capturing = 0
		if player.spectator then continue end
		activeplayers = $+1
		if not(player.playerstate == PST_LIVE and not(player.powers[pw_flashing]) and player.mo and player.mo.valid) then continue end
		if player.mo.flags&MF_NOCLIPTHING then continue end
		if not(P_CheckSight(mo,player.mo)) then continue end 
		if not(R_PointToDist2(player.mo.x,player.mo.y,mo.x,mo.y) < radius) then continue end
		if not(abs(player.mo.z-floor) < height) then continue end
		player.capturing = 1
		local t = player.ctfteam
		captureplayers = $+1
		if t then
			team[t] = $+1
		end
	end
	if G_GametypeHasTeams() and team[1] > 0 and team[2] > 0 then		//Capture blocked
		mo.color = SKINCOLOR_YELLOW
		if CP.Blocked != true then
			print("\x82 Capture blocked!")
			S_StartSound(mo,CP.BlockSFX)
			CP.Blocked = true
			for player in players.iterate
				local t = player.ctfteam
				if player.capturing and team[t] != max(team[1],team[2]) then
					P_AddPlayerScore(player,50)
				end
			end
		end
	elseif G_GametypeHasTeams() then	// Team capturing
		CP.Blocked = false
		for t = 1,2
			local amt = team[t]
			CP.TeamCapAmt[t] = $+amt
			if team[1] > team[2] then
				mo.color = SKINCOLOR_RED
			end
			if team[2] > team[1] then
				mo.color = SKINCOLOR_BLUE
			end
			for player in players.iterate
				if player.capturing and not(leveltime&3) then
					P_AddPlayerScore(player,1)
				end
			end
		end
		CP.LeadCapAmt = max(CP.TeamCapAmt[1],CP.TeamCapAmt[2])

	else //Free for all capture
		CP.Blocked = false
		for player in players.iterate()
			if player.capturing then
				local amt = 1+activeplayers-captureplayers
				player.captureamount = $+amt
				CP.LeadCapAmt = max($,player.captureamount)
				if player.captureamount == CP.LeadCapAmt and CP.LeadCapPlr != player then
					CP.LeadCapPlr = player
					print(player.name.." has taken the capture lead!")
				end
				if player == CP.LeadCapPlr then
					mo.color = player.skincolor
				end
				if not(leveltime&3)
					P_AddPlayerScore(player,amt)
				end
			end
		end
	end
	
	//Update capturing state
	if captureplayers == 0 or CP.Blocked then
		CP.Capturing = false
		CP.SFXtic = 1
	elseif CP.Capturing == false then
		CP.Capturing = true
		S_StartSound(mo,CP.StartCaptureSFX)
	elseif not(S_SoundPlaying(mo,CP.StartCaptureSFX)) then
		if CP.SFXtic == 1 then
			S_StartSound(mo,CP.CapturingSFX)
		end
		CP.SFXtic = Wrap($+1,8)
	end
	
	//Seize Point
	if CP.LeadCapAmt >= CV.CPMeter.value then
		CP.SeizePoint()
	end

	if captureplayers and not(CP.Blocked) then
		if not(leveltime&7) then
			for player in players.iterate
				if not(player.capturing) then continue end
				local b = P_SpawnMobj(mo.x,mo.y,mo.z,MT_CPBONUS)
				if b and b.valid then
					b.target = player.mo
					b.tracer = mo
					b.fuse = 10
					b.extravalue1 = b.fuse
					b.color = randomcolor()
					b.scale = $*2
				end
			end
		end
	end
end

CP.InertThinker = function(mo)
	mo.color = SKINCOLOR_CARBON
	mo.flags2 = ($|MF2_SHADOW)&~MF2_INVERTAIMABLE
end

CP.PointThinker = function(mo)
	//Get Orientation and surfaces
	local flip = P_MobjFlip(mo)
	local floor
	local ceil
	if flip == 1 then
		floor = mo.floorz
		ceil = mo.ceilingz
	else
		floor = mo.ceilingz
		ceil = mo.floorz
	end

	CP.PointHover(mo,floor,flip,ceil)

	//Do Active/Inactive Thinker instructions
	if CP.Active and mo == CP.ID[CP.Num] then
		CP.ActiveThinker(mo,floor,flip,ceil)
	else
		CP.InertThinker(mo)
	end
end

CP.ThinkFrame = function(mo)
	if not(CP.Gametype and CP.Mode) then return end
	
	if CP.Active == true then return end
	//Countdown to activate capture point
	CP.Timer = $-1
	if CP.Timer == TICRATE*10 then
		S_StartSound(nil,CP.HintSFX)
	end
	if (CP.Timer == TICRATE or CP.Timer == TICRATE*2 or CP.Timer == TICRATE*3) then
		S_StartSound(nil,sfx_s3ka7)
	end
	if CP.Timer <= 0 then
		CP.ActivatePoint()
	end
end

CP.SphereThinker = function(mo)
	local tc = mo.tracer
	local tg = mo.target
	local ev = mo.extravalue1
	local fs = mo.fuse
	if not(tc and tc.valid and tg and tg.valid and ev and fs) then
		if fs < ev and fs&1 then 
			mo.flags2 = $|MF2_SHADOW 
			mo.scale = FRACUNIT*fs/ev
		else
			mo.flags2 = $&~MF2_SHADOW
		end
	return end
	local frac = FRACUNIT*fs/ev
	local x = B.FixedLerp(tg.x,tc.x,frac)
	local y = B.FixedLerp(tg.y,tc.y,frac)
	local z = B.FixedLerp(tg.z+tg.height/2,tc.z+tc.height/2,frac)
	P_TeleportMove(mo,x,y,z)
end