local B = CBW_Battle

B.DoDebris=function(mo,large,speed)
	local scale
	if large then scale = mo.scale/2
	else scale = mo.scale/3
	end
	local debris = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ROCKCRUMBLE2)
	if debris and debris.valid then
		debris.scale = scale
		debris.flags2 = $|(mo.flags2&MF2_OBJECTFLIP)
		debris.z = $+FRACUNIT
		if P_IsObjectOnGround(mo) then
			P_InstaThrust(debris,P_RandomRange(0,259)*ANG1,speed*scale)
			debris.momz = speed*scale*P_MobjFlip(mo)
		else
			B.InstaThrustZAim(debris,mo.angle+ANGLE_180+P_RandomRange(-89,89)*ANG1,P_RandomRange(-89,89)*ANG1,speed*scale)
		end
	end
	return debris
end

B.Action.Dig=function(mo,doaction,throwring,tossflag)
	if mo.player.playerstate != PST_LIVE then 
		mo.flags2 = $&~MF2_DONTDRAW
-- 		mo.rollangle= 0
		return
	end
	if not(B.CanDoAction(mo.player)) then
		doaction = 0
		throwring = 0
		tossflag = 0
	end
	//Normal state; ready to dig
	if mo.player.actionstate == 0 then
		mo.player.actiontext = "Dig"
		mo.player.actionrings = 8
		mo.player.action2text = nil
		mo.player.action2rings = nil
	//1 = digging; 2 = downward air drill; disallow actions.
	elseif mo.player.actionstate != 3
		mo.player.actiontext = nil
		mo.player.action2text = nil
		doaction = 0
		throwring = 0
		tossflag = 0
	//3 = Burrowed. Ready to resurface.
	elseif mo.player.actionstate == 3 then
		mo.player.actiontext = "Rock Blast"
		mo.player.actionrings = 6
		mo.player.action2text = "Resurface"
	end
	if mo.player.actioncooldown and doaction then //(is this still necessary?)
		doaction = 0
		mo.player.payrings = -1
	end
	throwring = B.CheckRings(mo.player,$)

	if P_PlayerInPain(mo.player) and mo.player.actionstate then
		B.ResetPlayerProperties(mo.player,false,false)
		return
	end
	if doaction and throwring == 1 and mo.player.actionstate == 0 then
		B.PayRings(mo.player)
	end
	
	//Execute dig
	if (doaction and throwring == 1 and mo.player.actionstate == 0 and (P_IsObjectOnGround(mo) or mo.player.climbing))
		or (P_IsObjectOnGround(mo) and mo.player.actionstate == 2)
		then
		mo.player.actionstate = 1
		mo.player.actiontime = 0
		mo.flags = $|MF_NOCLIPTHING
		mo.flags2 = $|MF2_DONTDRAW
		mo.player.pflags = $|PF_JUMPSTASIS
		mo.player.normalspeed = skins[mo.skin].normalspeed/3
		S_StartSound(mo,sfx_s3kccs)
		return
	//Execute downward air drill
	elseif doaction and throwring == 1 and mo.player.actionstate == 0 then
		mo.player.actionstate = 2
		mo.player.actiontime = 0
		mo.state = S_PLAY_ROLL
-- 		mo.state = S_PLAY_NIGHTS_DRILL
-- 		mo.rollangle = ANGLE_270
-- 		for player in players.iterate
-- 			if player == displayplayer and displayplayer.truemo and displayplayer.truemo.valid then
-- 				mo.player.drawangle = displayplayer.truemo.angle-ANGLE_90
-- 			end
-- 		end
		local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
		local speed = FixedHypot(mo.momx,mo.momy)
		B.InstaThrustZAim(mo,dir,-ANGLE_90,min(speed,mo.scale*36))
		mo.momz = min(-12*mo.scale,mo.momz*P_MobjFlip(mo))*P_MobjFlip(mo)
		mo.player.pflags = $|(PF_JUMPED|PF_THOKKED)&~(PF_GLIDING)
		S_StartSound(mo,sfx_zoom)
		return
	end
	if mo.player.actionstate == 2 and mo.momz*P_MobjFlip(mo) > 0 then
		B.ResetPlayerProperties(mo.player,true,false)
	end

	if mo.player.actionstate != 1 and mo.player.actionstate != 3
		then return 
	//Eject player
	elseif (doaction and tossflag == 1) or not(P_IsObjectOnGround(mo) or mo.player.climbing) or not(mo.player.rings or mo.player.actionstate == 1) then
		P_SetObjectMomZ(mo,FRACUNIT*4,false)
		B.ResetPlayerProperties(mo.player,false,false)
		S_StartSound(mo,sfx_s3k82)
		for n = 0, 10
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(5,10))
		end
		mo.player.actioncooldown = TICRATE
		return
	end
	mo.flags = $|MF_NOCLIPTHING
	mo.flags2 = $|MF2_DONTDRAW
	mo.player.charability2 = 0
	
	mo.player.actiontime = $+1
	
	//Burrowing
	if mo.player.actionstate == 1
		mo.player.pflags = $|PF_JUMPSTASIS|PF_STASIS
		if mo.player.actiontime < TICRATE then
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(5,20))
		else
			mo.player.actionstate = 3
			mo.player.actiontime = -35
		end
		return
	end
	mo.player.pflags = ($|PF_JUMPSTASIS)&~PF_STASIS

	//Moving while burrowed
	if abs(mo.player.cmd.forwardmove) or abs(mo.player.cmd.sidemove) then
-- 		mo.player.actiontime = $+1 //Accelerate ring drain timer
		if not(mo.player.actiontime&3) then
			//Do Debris
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(3,5))
			S_StartSound(mo,sfx_s3k67)
		end
	end
	
	//Do ring drain
	if mo.player.actiontime >= 17 and mo.player.actionstate == 3 then
		mo.player.rings = max(0,$-1)
		S_StartSound(mo,sfx_itemup,mo.player)
		local spark = P_SpawnMobj(mo.x,mo.y,mo.z,MT_SPARK)
		mo.player.actiontime = 0
	end
	//Rock blast attack
	if (doaction and throwring==1) or B.PlayerButtonPressed(mo.player,BT_JUMP,false) or B.PlayerButtonPressed(mo.player,BT_USE,false)
		then
		mo.player.actionstate = 0
		B.PayRings(mo.player)
		mo.player.actioncooldown = TICRATE*5/2
		local grounded = P_IsObjectOnGround(mo)
		mo.player.pflags = $&~PF_JUMPSTASIS
		P_DoJump(mo.player,false)
		if mo.player.cmd.buttons&BT_JUMP then
			mo.player.pflags = $|PF_STARTJUMP|PF_JUMPDOWN
		end
		B.ResetPlayerProperties(mo.player,true,false)
		S_StartSound(mo,sfx_s3k59)
		for n = 0, 7
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(3,20))
		end
		if grounded then
			//Do horizontal debris burst
			for n = 0,7
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustZAim(rock,ANG10+ANGLE_45*n,ANG30*P_MobjFlip(rock),rock.scale*15)
					rock.fuse = 45
				end
			end
			//Second Layer
			for n = 0,15
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustZAim(rock,n*ANGLE_22h,ANG10*P_MobjFlip(rock),rock.scale*15)
					rock.fuse = 45
				end
			end
		else
			//Do vertical debris burst
			for n = 0,7
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustSpread(rock,mo.angle,30,45*n,FRACUNIT*20)
					rock.fuse = 45
				end
			end
			//Second Layer
			for n = 0,15
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustSpread(rock,mo.angle,60,225*n/10,FRACUNIT*15)
					rock.fuse = 45
				end
			end
		end
	end
end

