local B = CBW_Battle

B.Action.Sentry=function(mo,doaction,throwring,tossflag)
	mo.player.actionstate = 0
	if mo.player.sentrycount == nil then
		mo.player.sentrycount = 0
	end
	//Run checks
	if P_PlayerInPain(mo.player) or not(B.CanDoAction(mo.player)) then
		return
	end
	
	//Action Info
	mo.player.actiontext = "Sentry "..mo.player.sentrycount.."/3"
	mo.player.actionrings = 12
	if mo.player.sentrycount then
		mo.player.action2text = "Attack"
		mo.player.action2rings = 0
	end
-- 	doaction = B.CheckRings(mo.player,$)
	throwring = B.CheckRings(mo.player,$&1)

	//Spawn Sentry
	if doaction and throwring == 1 then 
		if mo.player.sentrycount < 3 then //Below spawn limit
			local sentry = P_SpawnMobj(mo.x,mo.y,mo.z,MT_BUZZBUDDY)
			if sentry and sentry.valid then
				sentry.target = mo
				sentry.scale = $/2
				sentry.ctfteam = mo.player.ctfteam
				sentry.followdist = P_RandomRange(48,128)*mo.scale
				sentry.followheight = P_RandomRange(-16,24)*mo.scale
				B.PayRings(mo.player)
				mo.player.actioncooldown = TICRATE

				S_StartSound(sentry,sfx_s3kb8)
				for l = 0,7
					P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,128*mo.scale,16,MT_NIGHTSPARKLE,mo.angle+45*l*ANG1,nil,1)
				end			
			end
		else //At spawn limit
			mo.player.spendrings = -1
		end
	end
	//Command Sentry to Attack
	if not(mo.player.actioncooldown) and doaction and tossflag == 1
		if mo.player.sentrycount > 0 then
			mo.player.actionstate = 1
		else
			mo.player.spendrings = -1
		end
	end
	mo.player.sentrycount = 0
end

B.BuzzBuddyThinker=function(mo)
	if not(mo.health) then return end
	//Do color
	if mo.target then
		mo.color = mo.target.color
		if mo.target.player and mo.target.player.sentrycount != nil then
			mo.target.player.sentrycount = $+1
		end
	end
	if mo.fuse and mo.target then
		mo.color = P_RandomRange(1,MAXSKINCOLORS-1)
	end
	//Air Drag
	local spd = FixedHypot(mo.momx,mo.momy)
	local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
-- 	P_Thrust(mo,dir,min(spd,mo.scale))
	if mo.target and mo.target.flags2&MF2_OBJECTFLIP then
		mo.flags2 = $|MF2_OBJECTFLIP
	else
		mo.flags2 = $&~MF2_OBJECTFLIP
	end
	if mo.target and mo.target.valid and mo.target.health and mo.target.player and B.ActionChar[mo.target.player.actiontype] == B.Action.Sentry then
		//Initiate attack
		if mo.target.player.actionstate == 1 and not(mo.tracer or mo.fuse) then
			mo.target.player.actionstate = 0
			local near = B.GetNearestPlayer(mo.target,90,-1)
			if not(near) then
				near = B.SearchObject(mo.target,mo.target.angle,90,512*FRACUNIT,MF_ENEMY|MF_BOSS|MF_MONITOR,mo,-1)
			else
				near = near.mo
			end
			if near and near.valid then
				mo.tracer = near
				mo.fuse = 25
				S_StartSound(mo,sfx_s3kc5s)
				mo.flags = $&~MF_NOCLIP
			return end
		end
	
		if mo.followheight == nil then
			mo.followheight = 0
		end
		if mo.followdist == nil then
			mo.followdist = 64*mo.scale
		end
	
		local dist = R_PointToDist2(mo.x,mo.y,mo.target.x,mo.target.y)
		local angle = R_PointToAngle2(mo.x,mo.y,mo.target.x,mo.target.y)
		local zdist = mo.target.z+(mo.target.height+mo.followheight)*P_MobjFlip(mo) - (mo.z+mo.height)
		local water = B.WaterFactor(mo)
		if not(mo.fuse) then
			//Follow
			if dist > mo.followdist then
				P_InstaThrust(mo,angle,max(0,(dist-mo.followdist)/8))
			end
			if abs(zdist) > 4*mo.scale
				mo.momz = max(min(8*mo.scale/water,$+zdist/16/water),-8*mo.scale/water)
			end
			mo.angle = angle
		//Attack ready; V-Align to tracer
		elseif mo.tracer and mo.tracer.valid then
			mo.angle = R_PointToAngle2(mo.x,mo.y,mo.tracer.x,mo.tracer.y)
			mo.momz = (mo.tracer.z-mo.z)/8/water
			P_InstaThrust(mo,R_PointToAngle2(0,0,mo.momx,mo.momy),FixedHypot(mo.momx,mo.momy)/10*9)
		end
		//Smoketrail
		if not(mo.flags&MF_NOCLIP) and not(mo.fuse&3) then
			local x = mo.x+P_ReturnThrustX(nil,mo.angle+180,mo.scale*3)
			local y = mo.y+P_ReturnThrustY(nil,mo.angle+180,mo.scale*3)
			P_SpawnMobj(x,y,mo.z+mo.height,MT_SPINDUST)
		end
	elseif (mo.flags&MF_SPECIAL)
		then
		//Self-destruct timer
		mo.fuse = TICRATE
		mo.flags = $&~(MF_NOCLIP|MF_SPECIAL|MF_ENEMY|MF_NOGRAVITY)
		mo.momz = 0
		mo.momx = 0
		mo.momy = 0		
	end
end

B.BuzzBuddyFuse=function(mo)
	//Kill object if no owner
	if not(mo.flags&MF_SPECIAL) then
		P_KillMobj(mo)
		return true
	end
	//Thrust toward target
	if mo.tracer and mo.tracer.valid then
		local water = B.WaterFactor(mo)
		P_InstaThrust(mo,mo.angle,mo.scale*60/water)
		mo.fuse = TICRATE*water
		mo.tracer = nil
		P_SetObjectMomZ(mo,FRACUNIT/water)
		S_StartSound(mo,sfx_zoom)
	else //Reset state
		mo.flags = $|MF_NOCLIP
	end
	
	return true
end

B.BuzzBuddyTouch=function(buzzmo,othermo)
	//Not a valid target
	if not(buzzmo.target and buzzmo.target.valid) then return end
	//Enemy or opposing player
	if not(buzzmo.target.player) or not(othermo.player) or B.MyTeam(othermo.player,buzzmo.target.player) == false then 
		//We're attacking if MF_NOCLIP is unflagged
		if not(buzzmo.flags&MF_NOCLIP) and (not(othermo.player) or B.PlayerCanBeDamaged(othermo.player)) then
			P_DamageMobj(othermo,buzzmo,buzzmo.target)
-- 			return false
		end
		//Do rest of code
		return
	end
	//Default (for friendly collisions)
	if othermo.player then othermo.player.homing = 0 end
	return true
end

B.BuzzBuddyDamage = function(buzzmo,inflictor,source)
	if buzzmo and buzzmo.valid and buzzmo.target and buzzmo.target.valid and buzzmo.target.player
		if source and source.valid and source.player
			if B.MyTeam(buzzmo.target.player,source.player)
				then 
				return false //Don't damage if a projectile is on our team
			end
		elseif inflictor and inflictor.valid and inflictor.player	
			if B.MyTeam(buzzmo.target.player,inflictor.player)
				then
				return false //Don't damage if inflictor is on our team
			end
		end
	end
end

B.BuzzBuddyCollide = function(buzzmo,othermo)
	if not(buzzmo.valid and othermo.valid) then return end
	if buzzmo.z > othermo.z+othermo.height then return end
	if othermo.z > buzzmo.z+buzzmo.height then return end
	if not(othermo.flags&(MF_MONITOR|MF_ENEMY|MF_BOSS) and othermo.health) then return end
	B.BuzzBuddyTouch(buzzmo,othermo)
end
