local TF_GRAY = 1
local TF_YELLOW = 2
local TF_RED = 3
local B = CBW_Battle
local CV = B.Console
local CP = B.ControlPoint


//-Special Moves-
local function actionhud(v, player, cam)
	if player.playerstate != PST_LIVE then return end
	if not(CV.Actions.value) then return end
	if player.actionallowed != true then return end
	if G_TagGametype() and leveltime < 30*TICRATE then return end
	
	local blink = false
	local xoffset = 16
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER
	local align = "thin"
	//Action 1 text
	local yoffset = 56
	local text = player.actiontext
	local textflags = player.actiontextflags
	if text and not(player.actioncooldown and leveltime&1) then 
		if player.actioncooldown then
			textflags = $|TF_GRAY
			text = "Cooldown "..player.actioncooldown/TICRATE
		end
		if (player.actionstate == 0 and player.actionrings > player.rings) then
			textflags = $|TF_GRAY
		end		
		if player.actionstate then
			textflags = $|TF_YELLOW
		end
		if textflags == TF_GRAY then
			text = "\x86"+$
		elseif textflags == TF_YELLOW then
			text = "\x82"+$
		elseif textflags == TF_RED then
			text = "\x85"+$
		else
			text = "\x80"+$
		end
		if player.actionrings and not(player.actioncooldown) then 
			text = "\x82"+player.actionrings+"\x80 "+$
		end
		//Draw
		local patch = v.cachePatch("THRWRING")
		v.draw(xoffset,yoffset,patch,flags)
		v.drawString(xoffset+12,yoffset,text,flags,align)
	end
	//Action 2 text
	yoffset = $+10
	text = player.action2text
	textflags = player.action2textflags
	if text and not(player.actioncooldown) then 
		if (player.actionstate == 0 and player.action2rings > player.rings) then
			textflags = $|TF_GRAY
		end		
		if player.actionstate then
			textflags = $|TF_YELLOW
		end
		if textflags == TF_GRAY then
			text = "\x86"+$
		elseif textflags == TF_YELLOW then
			text = "\x82"+$
		elseif textflags == TF_RED then
			text = "\x85"+$
		else
			text = "\x80"+$
		end
		if player.action2rings then 
			text = "\x82"+player.action2rings+"\x80 "+$
		end
		//Draw
		local patch = v.cachePatch("TOSSFLAG")
		v.draw(xoffset,yoffset,patch,flags)
		v.drawString(xoffset+12,yoffset,text,flags,align)
	end
	
	
	//DrawDebug
-- 	v.drawString(xoffset,yoffset+8,"actiontype: "+player.actiontype,flags)
-- 	v.drawString(xoffset,yoffset+16,"actionstate: "+player.actionstate,flags)
-- 	v.drawString(xoffset,yoffset+24,"actiontime: "+player.actiontime,flags)
-- 	v.drawString(xoffset,yoffset+32,"actionrings: "+player.actionrings,flags)
-- 	v.drawString(xoffset,yoffset+40,"actioncooldown: "+player.actioncooldown,flags)

end

//Control Point
local function cphud(v, player, cam)
	if not(player.truemo and CP.Mode and server) then return end
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_PERPLAYER
	local xoffset = 152
	local yoffset = 4
	local time = CP.Timer
	local angle
	local compass
	local color
	local pid = CP.ID[CP.Num]
	if CP.Active or (time <= 10*TICRATE and time&1) and player.truemo and player.truemo.valid and pid and pid.valid then
		angle = R_PointToAngle2(player.truemo.x,player.truemo.y,pid.x,pid.y) - R_PointToAngle(player.truemo.x,player.truemo.y)
		compass = v.getSpritePatch("CMPS",A,min(8,max(1,-(angle)/ANG1/40+5))) //Angle math is weird, idk
		local pcol = pid.color
		if (G_GametypeHasTeams() and not(CP.Capturing or CP.Blocked)) or pid.color == SKINCOLOR_JET then
			pcol = SKINCOLOR_SILVER
		end
		color = v.getColormap(TC_DEFAULT,pcol)
		//Draw
		v.draw(xoffset,yoffset,compass,flags,color)
	end
	local text = ""
	local center = 8
	local left = -2
	local right = 20
	local blue = center-1
	local red = center+1
	local bottom = 12
	local centeralign = "center"
	local leftalign = "thin-right"
	local rightalign = "thin"
	if time then
		text = time/TICRATE
		v.drawString(xoffset+center,yoffset+bottom,text,flags,centeralign)
	elseif CP.Active then
		if not(G_GametypeHasTeams()) then
			text = "\x82"..CP.LeadCapAmt*100/CV.CPMeter.value.."%"
			v.drawString(xoffset+right,yoffset+4,text,flags,rightalign)
			if player.mo and CP.Active
				text = player.captureamount*100/CV.CPMeter.value.."%"
				v.drawString(xoffset+left,yoffset+4,text,flags,leftalign)
			end
		else
			text = CP.TeamCapAmt[2]*100/CV.CPMeter.value.."%"
			v.drawString(xoffset+blue,yoffset+4+bottom,text,flags,leftalign)
			text = CP.TeamCapAmt[1]*100/CV.CPMeter.value.."%"
			v.drawString(xoffset+red,yoffset+4+bottom,text,flags,rightalign)
		end		
	end
end

hud.add(actionhud, player)
hud.add(cphud, player)