//These functions are deprecated and will be removed in the next patch!


local KP = KingPanel
local B = CBW_Battle
local panelvars = {KP.kingpanelmode,KP.currentpanel,KP.paneltimer,KP.paneltics,KP.panelwait}
//"constants"
local panel_name = {"Bounce","Rail","Auto","Explode","Scatter","Grenade"}
local wepstart = MT_BOUNCEPICKUP-1
local PrePanelTime = KP.CV_PrePanelTime
local PanelTime = KP.CV_PanelTime
local PanelWait = KP.CV_PanelWaitTime

//-Initialize KingPanel Game mode-
B.InitKingGame = function()
	KP.kingpanelmode = false
	KP.panel_id = {nil,nil,nil,nil,nil,nil}
	KP.currentpanel = P_RandomRange(1,6)
	KP.paneltimer = PrePanelTime.value*TICRATE
	KP.panelwait = true
end

//-Initialize Panel-
B.InitKingPanel = function(mo)
	if G_RingSlingerGametype() then return end
	
	if B.BattleGametype() and not(gametype == GT_BATTLE or gametype == GT_TEAMBATTLE) then
		mo.ctfteam = 0
		mo.flags = ($|MF_NOCLIPTHING)&~MF_SPECIAL
		mo.flags2 = $|MF2_DONTDRAW
		return
	end
	if KP.kingpanelmode == false then
		print("Game mode is now King of the Panel")
		KP.kingpanelmode = true
	end
	mo.target = nil //Free target, in case it hasn't been freed already
	mo.ctfteam = 0 //Used to check that the target hasn't switched teams
	mo.flags = ($|MF_NOCLIPTHING)&~MF_SPECIAL
	mo.flags2 = $|MF2_SHADOW

	//Tracking game panels
	local i = mo.type - wepstart
	if KP.panel_id[i] and KP.panel_id[i].valid then
		if KP.panel_id[i].z > mo.z then
			print(panel_name[i].." Panel id replaced with new panel id")
			KP.panel_id[i].flags2 = $|MF2_DONTDRAW
			KP.panel_id[i] = mo
		else
			print("Redundant "..panel_name[i].." Panel removed")
			mo.flags2 = $|MF2_DONTDRAW
		end
	else
		KP.panel_id[i] = mo
		print(panel_name[i].." Panel id allocated")
	end
end

//-Set new King Panel-
B.SetKingPanel = function(mo)
	if KP.kingpanelmode == false then return end
	if KP.currentpanel
		local kingpanel = KP.panel_id[KP.currentpanel]
		if kingpanel and kingpanel.valid then
			//Reward Points
			if kingpanel.target and kingpanel.target.valid then
				local points = 100+KP.paneltics/TICRATE*10
				P_AddPlayerScore(kingpanel.target.player,points)
				local name = kingpanel.target.player.name
				if G_GametypeHasTeams() then
					if kingpanel.target.player.ctfteam == 1 then
						name = "\x85"..$.."\x80"
					else
						name = "\x84"..$.."\x80"
					end
				end
				local pname = "\x82"..panel_name[KP.currentpanel].." Panel\x80"
				print(name.." received "..points.." additional points for holding onto the "..pname.." for "..KP.paneltics/TICRATE.." seconds.")
				for player in players.iterate
					if not player.mo or secondarydisplayplayer == player then continue end
					if player.spectator or player.mo == kingpanel.target or (G_GametypeHasTeams() and player.ctfteam == kingpanel.target.player.ctfteam)
						then S_StartSound(player.mo,sfx_flgcap,player)
					else
						S_StartSound(player.mo,sfx_lose,player)
					end
				end
			elseif not(KP.panelwait) then
				print("No one claimed the "..panel_name[KP.currentpanel].." Panel before it disappeared.")
			end
			kingpanel.target = nil
			kingpanel.ctfteam = 0
			kingpanel.flags = ($|MF_NOCLIPTHING)&~MF_SPECIAL
			kingpanel.flags2 = $|MF2_SHADOW
		end
	end
	//Do intermission
	if KP.panelwait == false then
		KP.panelwait = true
		KP.paneltics = 0
		KP.paneltimer = PanelWait.value*TICRATE
		return
	end
	
	//Do next panel
	KP.panelwait = false
	local panelstart = KP.currentpanel
	local function panelwrap(num)
		if num > 6 then
			num = $-6
		end
		return num
	end
	KP.currentpanel = panelwrap($+P_RandomRange(1,5))
-- 	print(KP.currentpanel)
	local function unlockpanel()
		KP.panel_id[KP.currentpanel].flags = ($&~MF_NOCLIPTHING)|MF_SPECIAL
		KP.panel_id[KP.currentpanel].flags2 = $&~MF2_SHADOW
		KP.paneltics = 0
		KP.paneltimer = PanelTime.value*TICRATE
		S_StartSound(nil,sfx_s3kad)
		print("The \x82"..panel_name[KP.currentpanel].." Panel\x80 has been unlocked!")
	end
	
	if KP.panel_id[KP.currentpanel] and KP.panel_id[KP.currentpanel].valid then
		unlockpanel()
	else //Panel hasn't been found. What gives?
-- 		print("panel not found. searching for next...")
		local ThereArePanels = false
		for n = 1,6
			if KP.panel_id[n] and KP.panel_id[n].valid then
				ThereArePanels = true
				break
			end
		end
		//No panels left?
		if ThereArePanels == false then
			print("Attempted to find a score panel, but no valid panel ids are currently allocated. Exiting King of the Panel mode")
			KP.kingpanelmode = false
			KP.paneltimer = PanelWait.value*TICRATE
			KP.panelwait = true
		else //So there are panels. Fine, let's just go through them sequentially
			KP.currentpanel = panelstart+1
			while not(KP.panel_id[KP.currentpanel]) //Keep running until we find a valid id
				KP.currentpanel = panelwrap($+1)
			end
			unlockpanel()
		end
-- 		print("No panel id found for type: "..panel_name[KP.currentpanel])
	end
end

//-Player touches KingPanel Panel-
B.TouchKingPanel = function(mo,pmo)
	if not(KP.kingpanelmode) then return end //Make sure the mode has properly registered first
	if not(mo.target != pmo) then return end //This player has already touched it
	if pmo.player.powers[pw_flashing] or pmo.player.playerstate != PST_LIVE then return end //This player is flashing or dead
	if mo.target and KP.paneltics < 15 then return end //Wait a second before re-tagging
	if not(mo.ctfteam != pmo.ctfteam or gametype == GT_MATCH) then return end //This team already has the panel
	local lasttarget = mo.target
	local lastteam = mo.ctfteam
	mo.target = pmo
	mo.ctfteam = pmo.player.ctfteam
	if not(G_GametypeHasTeams()) or lastteam != mo.ctfteam then
		KP.paneltics = 0
	end
	local name = pmo.player.name
	if G_GametypeHasTeams()
		if mo.ctfteam == 1 then
			name = "\x85"..$.."\x80"
		else
			name = "\x84"..$.."\x80"
		end
	end
	local pname = "\x82"..panel_name[KP.currentpanel].." Panel\x80"
	if not(lasttarget and lasttarget.valid) then
		print(name.." tagged the "..pname.."!")
	else
		local name2 = lasttarget.player.name
		if G_GametypeHasTeams()
			if lastteam == 1 then
				name2 = "\x85"..$.."\x80"
			else
				name2 = "\x84"..$.."\x80"
			end
		end	
		print(name.." stole the "..pname.." from "..name2.."!")
	end
	if not(G_GametypeHasTeams() and lastteam == mo.ctfteam) or not(lastteam) then
		S_StartSound(nil,sfx_lvpass)
	else
		S_StartSound(mo,sfx_lvpass)
	end
end

//-Update KingPanel Panel-
B.UpdateKingPanel = function(mo)
	if mo.ctfteam == nil then B.InitKingPanel(mo) end //Make sure we're properly initialized
	if mo.target == nil then return end
	KP.paneltics = $+1
	local pmo = mo.target
	local player = pmo.player
	if not(pmo.valid and player.ctfteam == mo.ctfteam) then
		mo.ctfteam = 0
		mo.target = nil
-- 		print("The Panel's target no longer exists.")
	elseif not(leveltime&15) then
		P_AddPlayerScore(player,5)
		local o = P_SpawnMobj(mo.x,mo.y,mo.z,MT_THOK)
		o.color = mo.target.player.skincolor
	end
end

//-Update KingPanel Mode-
B.UpdateKingMode = function()
	if (KP.kingpanelmode and server) then
		if not(KP.paneltics == nil) then 
			//Check if current panel is valid
			if not(KP.panelwait)
				and not(KP.panel_id[KP.currentpanel] and KP.panel_id[KP.currentpanel].valid)
				then
				KP.currentpanel = 0
				KP.panelwait = true
				KP.paneltimer = PanelWait.value*TICRATE
			end
			//Do timer
			KP.paneltimer = $-1
			if (KP.paneltimer == TICRATE or KP.paneltimer == TICRATE*2 or KP.paneltimer == TICRATE*3) then
				S_StartSound(nil,sfx_s3ka7)
			end
			if KP.paneltimer <= 0 then
				B.SetKingPanel()
			end
		end
	end
end


